#include <cstdlib>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <strstream>
#include <math.h>

using namespace std;

    //Config
    struct STAnaConfig{
         double EvMaxTsh; //wartosc graniczna uniesienia ST dla wyznaczenia epizodu
         double EvMinTsh; //wartosc graniczna obnienia ST dla wyznaczenia epizodu
         double EvSlpTsh; //wartosc graniczna nachylenia ST dla wyznaczenia epizodug
         double HR;   //HR
    };

    //Beats
    struct STPar
    {
         struct MeasPos{
               double BL;
               double J;
               double ST;
         };    
         struct MeasVal{
               double BL;
               double J;
               double ST;
         };        
         int MaxCh;  
         int MinCh;
         double MaxVal;
         double MinVal;     
    };

double getValJ(double data1, STAnaConfig a){
     char* str1 = new char[30];
     char* str2 = new char[30];
    
    if(a.HR != 0.0)
    {
          float f1 = data1*(1.0/360.0)+ ((40+(0.948*sqrt(a.HR)))/1000) - 0.001;
          sprintf(str1, "%.7g", f1 );   
          float f2 = data1*(1.0/360.0)+ ((40+(0.948*sqrt(a.HR)))/1000) + 0.002;
          sprintf(str2, "%.7g", f2 ); 
    }else{
          float f1 = data1*(1.0/360.0)+0.044;
          sprintf(str1, "%.7g", f1 );   
          float f2 = data1*(1.0/360.0)+0.047;
          sprintf(str2, "%.7g", f2 ); 
    }
    
    std::string polecenie = "rdsamp -p -s 0 -r 100 ";
    std::string o1 = str1; //0:0.185
    std::string o2 = str2; //0:0.19
    std::string arg_wywolania_str = polecenie + "-f 0:"+ o1 + " -t 0:" + o2 + " >temp.txt";
                    
    //cout<<"arg wywolania: "<<arg_wywolania_str<<endl;
                    
    int rozmiar=arg_wywolania_str.size();
    char arg_wywolania_arr[100];
    for (int a=0;a<=rozmiar;a++)
    {
        arg_wywolania_arr[a]=arg_wywolania_str[a];
    }
                                  
    system(arg_wywolania_arr);
    
    float data2;           
    ifstream fin2;     

    fin2.open("temp.txt",ios::in);    
    assert (!fin2.fail( ));                   

    int l=0;
    while (!fin2.eof( ))     
    {
          fin2 >> data2;    //odczytywana tylko pierwsza wartosc          
          if(l==1){
                   //cout<<"wart w J: "<< data2 << endl;    
                   fin2.close();       //close file
                   return data2;   
          }
          l++;
    }
    return 0.0;
}

double getValSt(double data1, STAnaConfig a){
     char* str1 = new char[30];
     char* str2 = new char[30];
    
    if(a.HR != 0.0)
    {
          float f1 = data1*(1.0/360.0)+ ((40+(2.21*sqrt(a.HR)))/1000) - 0.001;
          sprintf(str1, "%.7g", f1 );   
          float f2 = data1*(1.0/360.0)+ ((40+(2.21*sqrt(a.HR)))/1000) + 0.002;
          sprintf(str2, "%.7g", f2 ); 
    }else{
          float f1 = data1*(1.0/360.0)+0.059;
          sprintf(str1, "%.7g", f1 );   
          float f2 = data1*(1.0/360.0)+0.062;
          sprintf(str2, "%.7g", f2 ); 
    }
    
    std::string polecenie = "rdsamp -p -s 0 -r 100 ";
    std::string o1 = str1; //0:0.185
    std::string o2 = str2; //0:0.19
    std::string arg_wywolania_str = polecenie + "-f 0:"+ o1 + " -t 0:" + o2 + " >temp.txt";
                    
    //cout<<"arg wywolania: "<<arg_wywolania_str<<endl;
                    
    int rozmiar=arg_wywolania_str.size();
    char arg_wywolania_arr[100];
    for (int a=0;a<=rozmiar;a++)
    {
        arg_wywolania_arr[a]=arg_wywolania_str[a];
    }
                                  
    system(arg_wywolania_arr);
    
    float data2;           
    ifstream fin2;     

    fin2.open("temp.txt",ios::in);    
    assert (!fin2.fail( ));                   

    int l=0;
    while (!fin2.eof( ))     
    {
          fin2 >> data2;    //odczytywana tylko pierwsza wartosc          
          if(l==1){
                   //cout<<"wart w ST: "<< data2 << endl;    
                   fin2.close();       //close file
                   return data2;
          }
          l++;
    }
    return 0.0;
}
    
    STAnaConfig wypelnij(){
         STAnaConfig a;
         cout<<"podaj graniczne uniesienie [mV]: ";
         cin>>a.EvMaxTsh;
         cout<<"podaj graniczne obnizenie [mV]: ";
         cin>>a.EvMinTsh;
         cout<<"podaj graniczne nachylenie [tg]: ";
         cin>>a.EvSlpTsh;
         cout<<"podaj HR: ";
         cin>>a.HR;
         return a;
    }

int main(int argc, char *argv[])
{

    double minVal[100];
    double maxVal[100];
    double maxTg[100];
    
    for(int i=0;i<100;i++){
         minVal[i] = 0.0;
         maxVal[i] = 0.0;
         maxTg[i] = 0.0;
    }

    STAnaConfig a = wypelnij();
    
    //szybkie podliczenie dlugosci:
    double len = 1.0;
    if(a.HR != 0.0)
    {
          double a1 = ((40+(0.948*sqrt(a.HR)))/1000);
          double a2 = ((40+(2.21*sqrt(a.HR)))/1000); 
          len = a2 - a1;
    }else{
          len = 15.0;
    }          

    //cout<<system("rdsamp -p -s 0 -r 100 -v -f 0:0.000 -t 0:0.001");
    //odczytywanie danych Q-----------------------------------------------------
    
    float data1;           
    ifstream fin1;   
        
    fin1.open("100.qrs",ios::in);    // otwieranie pliku z wynikami QRS_DET
    assert (!fin1.fail( ));   
    
    double bl = 0.0;
    int j=0;
     while (!fin1.eof( ))     
     {
          if(j==600)
                  break;
                    
          fin1 >> data1;
          
          
          if(j%6==1 || j%6==2){
                    if(j%6==1){
                         //cout<<"wartosc BL: "<< data1 << endl;
                         bl=data1; 
                    }
                    if(j%6==2){
                         double j=getValJ(data1, a);
                         double st=getValSt(data1, a);       
                         
                         if( (((j+st)/2)>bl) && ((j+st)/2)>(bl+a.EvMaxTsh)   ){      
                             double pol1=0.0;
                             double pol2=0.0;
                             if(a.HR == 0){
                                 pol1 = data1*(1.0/360.0)+0.045;
                                 pol1 = data1*(1.0/360.0)+0.06;
                             }    
                             else{
                                 pol1 = data1*(1.0/360.0)+ (40+(0.948*sqrt(a.HR)))/1000;
                                 pol2 = data1*(1.0/360.0)+ (40+(2.21*sqrt(a.HR)))/1000;
                             }
                            if(((((j+st)/2)-bl)*10) < 4){    
                                 cout<<"Amplituda izolinii: "<<bl<<endl;
                                 cout<<"Polozenie J: "<<pol1<<" Amplituda w punkcie: "<<j<<endl;
                                 cout<<"Polozenie ST: "<<pol2<<" Amplituda w punkcie: "<<st<<endl;   
                                 cout<<"Uniesienie : "<<(((j+st)/2)-bl)*10<<" [mm]"<<endl;
                             }                       
                         }
                         else if( (((j+st)/2)<bl) && ((j+st)/2)<(bl-a.EvMinTsh)   ){ 
                             double pol1=0.0;
                             double pol2=0.0;
                             if(a.HR == 0){
                                 pol1 = data1*(1.0/360.0)+0.045;
                                 pol1 = data1*(1.0/360.0)+0.06;
                             }    
                             else{
                                 pol1 = data1*(1.0/360.0)+ (40+(0.948*sqrt(a.HR)))/1000;
                                 pol2 = data1*(1.0/360.0)+ (40+(2.21*sqrt(a.HR)))/1000;
                             }
                            if(((((j+st)/2)-bl)*10) < 4){    
                                 cout<<"Amplituda izolinii: "<<bl<<endl;
                                 cout<<"Polozenie J: "<<pol1<<" Amplituda w punkcie: "<<j<<endl;
                                 cout<<"Polozenie ST: "<<pol2<<" Amplituda w punkcie: "<<st<<endl;   
                                 cout<<"Obnizenie: "<<(bl-((j+st)/2))*(-10)<<" [mm]"<<endl;
                             }       
                         }  
                    }
          } 
          j++;             
     }
     
     fin1.close();       //close file
    //--------------------------------------------------------------------------

    system("PAUSE");  
    return EXIT_SUCCESS;
}
